//----------------------------------------------------------------------------
// HtmlDB.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: HtmlDB.pas
//----------------------------------------------------------------------------
#ifndef HtmlDBHPP
#define HtmlDBHPP
//----------------------------------------------------------------------------
#include <DBTables.hpp>
#include <DB.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <Windows.hpp>
#include <SysUtils.hpp>
#include <Dialogs.hpp>
#include <System.hpp>
namespace Htmldb
{
//-- type declarations -------------------------------------------------------
enum THAlign { haDefault, haLeft, haRight, haCenter };

enum TVAlign { vaDefault, vaTop, vaBottom };

enum TFieldWidthType { fwAuto, fwRelative, fwPixel };

enum TFontSize { fsDefault, fsSize1, fsSize2, fsSize3, fsSize4, fsSize5, fsSize6, fsSize7 };

enum TBrowserMode { modeNetscape, modeMSIE };

class __declspec(delphiclass) TGridStyle;
class __declspec(pascalimplementation) TGridStyle : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	int FBorderWidth;
	int FCellSpacingWidth;
	int FCellPaddingWidth;
	bool FBorder;
	bool FCellSpacing;
	bool FCellPadding;
	
__published:
	__property bool Border = {read=FBorder, write=FBorder, default=1};
	__property int BorderWidth = {read=FBorderWidth, write=FBorderWidth, default=1};
	__property bool CellPadding = {read=FCellPadding, write=FCellPadding, nodefault};
	__property int CellPaddingWidth = {read=FCellPaddingWidth, write=FCellPaddingWidth, default=1};
	__property bool CellSpacing = {read=FCellSpacing, write=FCellSpacing, nodefault};
	__property int CellSpacingWidth = {read=FCellSpacingWidth, write=FCellSpacingWidth, default=1};
public:
		
	/* TObject.Create */ __fastcall TGridStyle(void) : Classes::TPersistent() { }
	/* TObject.Destroy */ __fastcall virtual ~TGridStyle(void) { }
	
};

class __declspec(delphiclass) TGridContent;
class __declspec(pascalimplementation) TGridContent : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FRecordNumber;
	bool FReversed;
	int FMaxRows;
	int FStartRow;
	
__published:
	__property int MaxRows = {read=FMaxRows, write=FMaxRows, default=-1};
	__property int StartRow = {read=FStartRow, write=FStartRow, default=-1};
	__property bool RecordNumber = {read=FRecordNumber, write=FRecordNumber, nodefault};
	__property bool Reversed = {read=FReversed, write=FReversed, nodefault};
public:
	/* TObject.Create */ __fastcall TGridContent(void) : Classes::TPersistent() { }
	/* TObject.Destroy */ __fastcall virtual ~TGridContent(void) { }
	
};

class __declspec(delphiclass) TGridTitle;
class __declspec(pascalimplementation) TGridTitle : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	System::AnsiString FCaption;
	TVAlign FVAlign;
	bool FBold;
	bool FUnderline;
	bool FItalic;
	
__published:
	__property TVAlign VAlign = {read=FVAlign, write=FVAlign, nodefault};
	__property System::AnsiString Caption = {read=FCaption, write=FCaption, nodefault};
	__property bool Bold = {read=FBold, write=FBold, nodefault};
	__property bool Italic = {read=FItalic, write=FItalic, nodefault};
	__property bool Underline = {read=FUnderline, write=FUnderline, nodefault};
public:
	/* TObject.Create */ __fastcall TGridTitle(void) : Classes::TPersistent() { }
	/* TObject.Destroy */ __fastcall virtual ~TGridTitle(void) { }
	
};

class __declspec(delphiclass) TGridHeader;
class __declspec(pascalimplementation) TGridHeader : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	THAlign FAlign;
	bool FVisible;
	Graphics::TColor FTextColor;
	Graphics::TColor FBGColor;
	TFontSize FSize;
	bool FBold;
	bool FUnderline;
	bool FItalic;
	
__published:
	__property THAlign Align = {read=FAlign, write=FAlign, nodefault};
	__property Graphics::TColor TextColor = {read=FTextColor, write=FTextColor, nodefault};
	__property Graphics::TColor BGColor = {read=FBGColor, write=FBGColor, nodefault};
	__property TFontSize Size = {read=FSize, write=FSize, default=0};
	__property bool Bold = {read=FBold, write=FBold, nodefault};
	__property bool Italic = {read=FItalic, write=FItalic, nodefault};
	__property bool Underline = {read=FUnderline, write=FUnderline, nodefault};
	__property bool Visible = {read=FVisible, write=FVisible, default=1};
public:
	/* TObject.Create */ __fastcall TGridHeader(void) : Classes::TPersistent() { }
	/* TObject.Destroy */ __fastcall virtual ~TGridHeader(void) { }
	
};

typedef void __fastcall (__closure *TCustomiseRowEvent)(System::TObject* Sender, Graphics::TColor &TextColor
	, Graphics::TColor &BGColor);

typedef void __fastcall (__closure *TCustomiseFieldEvent)(System::TObject* Sender, Db::TField* Field
	,  System::AnsiString &FieldString,  System::AnsiString &Link,  System::AnsiString &Image, TFieldWidthType 
	&FieldWidthType, Graphics::TColor &TextColor, Graphics::TColor &BGColor, TFontSize &FontSize, bool 
	&Bold, bool &Italic, bool &NoFlow, bool &NoWrap);

typedef void __fastcall (__closure *TDrawTextEvent)( System::AnsiString Text);

class __declspec(delphiclass) THtmlDBGrid;
class __declspec(pascalimplementation) THtmlDBGrid : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	THAlign FAlign;
	Db::TDataSet* FDataSet;
	System::AnsiString FBackGround;
	Graphics::TColor FBGColor;
	Graphics::TColor FTextColor;
	TGridTitle* FTitle;
	TGridHeader* FHeader;
	TGridStyle* FStyle;
	TGridContent* FContent;
	TCustomiseRowEvent FOnCustomiseRow;
	TCustomiseFieldEvent FOnCustomiseField;
	TDrawTextEvent FOnDrawText;
	void __fastcall SetTitle(TGridTitle* Value);
	void __fastcall SetHeader(TGridHeader* Value);
	void __fastcall SetStyle(TGridStyle* Value);
	void __fastcall SetContent(TGridContent* Value);
	void __fastcall SetDataSet(Db::TDataSet* Value);
	System::AnsiString __fastcall WWWColor(Graphics::TColor Color);
	
protected:
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	virtual void __fastcall StartGrid(void);
	virtual void __fastcall DrawTitles(void);
	virtual void __fastcall DrawRow(void);
	virtual void __fastcall EndGrid(void);
	
public:
	__fastcall virtual THtmlDBGrid(Classes::TComponent* AOwner);
	void __fastcall DrawGrid(TBrowserMode Mode);
	
__published:
	__property THAlign Align = {read=FAlign, write=FAlign, default=0};
	__property System::AnsiString BackGround = {read=FBackGround, write=FBackGround, nodefault};
	__property Graphics::TColor BGColor = {read=FBGColor, write=FBGColor, default=536870911};
	__property Graphics::TColor TextColor = {read=FTextColor, write=FTextColor, default=536870911};
	__property TGridTitle* Title = {read=FTitle, write=SetTitle, nodefault};
	__property TGridHeader* Header = {read=FHeader, write=SetHeader, nodefault};
	__property TGridStyle* Style = {read=FStyle, write=SetStyle, nodefault};
	__property TGridContent* Content = {read=FContent, write=SetContent, nodefault};
	__property Db::TDataSet* DataSet = {read=FDataSet, write=SetDataSet, nodefault};
	__property TCustomiseRowEvent OnCustomiseRow = {read=FOnCustomiseRow, write=FOnCustomiseRow};
	__property TCustomiseFieldEvent OnCustomiseField = {read=FOnCustomiseField, write=FOnCustomiseField
		};
	__property TDrawTextEvent OnDrawText = {read=FOnDrawText, write=FOnDrawText};
public:
	/* TComponent.Destroy */ __fastcall virtual ~THtmlDBGrid(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
extern Sysutils::Exception* NoDataSetAssigned;
extern void __fastcall Register(void);

}	/* namespace Htmldb */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Htmldb;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// HtmlDB
